"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.rememberCache = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _Decorators = require("./Decorators");

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _appName;

var rememberCache =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee(keyname, second, callback) {
    var key, __cachem, avalue;

    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!((typeof window === "undefined" ? "undefined" : _typeof(window)) === "object")) {
              _context.next = 2;
              break;
            }

            throw new Error('rememberCache函数仅限于Server端运行！无法在浏览器端中');

          case 2:
            _appName = _appName || (0, _util.load_package_name)();
            key = "gkcache_".concat(_appName, "-").concat(keyname);
            __cachem = (0, _Decorators.getCacheManage)();
            avalue = __cachem.get(key);

            if (!avalue) {
              _context.next = 8;
              break;
            }

            return _context.abrupt("return", avalue);

          case 8:
            avalue = callback();
            setImmediate(function () {
              __cachem.set(key, second, avalue);
            });
            return _context.abrupt("return", avalue);

          case 11:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function rememberCache(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

exports.rememberCache = rememberCache;